VERSION 5.00
Begin VB.UserControl FOTAKeyState 
   ClientHeight    =   1620
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1245
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   1620
   ScaleWidth      =   1245
   ToolboxBitmap   =   "FOTAKeyState.ctx":0000
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   510
      Left            =   0
      Picture         =   "FOTAKeyState.ctx":0312
      ScaleHeight     =   480
      ScaleWidth      =   480
      TabIndex        =   0
      Top             =   0
      Width           =   510
   End
   Begin VB.Timer tmrKeyStateCheck 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   720
      Top             =   960
   End
End
Attribute VB_Name = "FOTAKeyState"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_oFunctions As New clsFunctions
Private m_nPollingRate As Long
Private m_bEnabled As Boolean

Private m_bReportCatigory_Mouse As Boolean
Private m_bReportCatigory_Misc As Boolean
Private m_bReportCatigory_Alpha As Boolean
Private m_bReportCatigory_Keypad As Boolean
Private m_bReportCatigory_FKeys As Boolean


Public Event KeyPressed(nKey As ENUM_ASCII_KEYS, bToggled As Boolean)

Public Property Get Enabled() As Boolean
    Enabled = m_bEnabled
End Property
Public Property Let Enabled(bNewEnabled As Boolean)
    m_bEnabled = bNewEnabled
    UserControl.tmrKeyStateCheck.Enabled = m_bEnabled
End Property

Public Property Get PollingRate() As Long
    PollingRate = m_nPollingRate
End Property
Public Property Let PollingRate(nNewRate As Long)
    m_nPollingRate = nNewRate
End Property

Public Property Get Report_Mouse() As Boolean
    Report_Mouse = m_bReportCatigory_Mouse
End Property
Public Property Let Report_Mouse(bReport_Mouse As Boolean)
    m_bReportCatigory_Mouse = bReport_Mouse
End Property

Public Property Get Report_Misc() As Boolean
    Report_Misc = m_bReportCatigory_Misc
End Property
Public Property Let Report_Misc(bReport_Misc As Boolean)
    m_bReportCatigory_Misc = bReport_Misc
End Property

Public Property Get Report_Alpha() As Boolean
    Report_Alpha = m_bReportCatigory_Alpha
End Property
Public Property Let Report_Alpha(bReport_Alpha As Boolean)
    m_bReportCatigory_Alpha = bReport_Alpha
End Property

Public Property Get Report_Keypad() As Boolean
    Report_Keypad = m_bReportCatigory_Keypad
End Property
Public Property Let Report_Keypad(bReport_Keypad As Boolean)
    m_bReportCatigory_Keypad = bReport_Keypad
End Property

Public Property Get Report_FKeys() As Boolean
    Report_FKeys = m_bReportCatigory_FKeys
End Property
Public Property Let Report_FKeys(bReport_FKeys As Boolean)
    m_bReportCatigory_FKeys = bReport_FKeys
End Property

Private Sub tmrKeyStateCheck_Timer()
    
    Dim nShift As Long
    Dim bToggled As Boolean
    Dim i As Long
    
    If m_bReportCatigory_Mouse = True Then
        Call Test(VK_LBUTTON)      ' &H1
        Call Test(VK_RBUTTON)      ' &H2
        Call Test(VK_CANCEL)      ' &H3
        Call Test(VK_MBUTTON)      ' &H4 'NOT contiguous with L RBUTTON
    End If
    
    If m_bReportCatigory_Misc = True Then
        Call Test(KF_EXTENDED)      ' &H100
        Call Test(KF_DLGMODE)      ' &H800
        Call Test(KF_MENUMODE)      ' &H1000
        Call Test(KF_ALTDOWN)      ' &H2000
        Call Test(KF_REPEAT)      ' &H4000
        Call Test(KF_UP)      ' &H8000

        Call Test(VK_BACK)      ' &H8
        Call Test(VK_CLEAR)      ' &HC
        Call Test(VK_MENU)      ' &H12
        Call Test(VK_PAUSE)      ' &H13
        Call Test(VK_CAPITAL)      ' &H14

        Call Test(VK_PRIOR)      ' &H21

        Call Test(VK_SELECT)      ' &H29
        Call Test(VK_PRINT)      ' &H2A
        Call Test(VK_EXECUTE)      ' &H2B
        Call Test(VK_SNAPSHOT)      ' &H2C
        Call Test(VK_INSERT)      ' &H2D
        Call Test(VK_DELETE)      ' &H2E
        Call Test(VK_HELP)      ' &H2F
        
        Call Test(VK_LMENU)      ' &HA4
        Call Test(VK_RMENU)      ' &HA5

        Call Test(VK_ATTN)      ' &HF6
        Call Test(VK_CRSEL)      ' &HF7
        Call Test(VK_EXSEL)      ' &HF8
        Call Test(VK_EREOF)      ' &HF9
        Call Test(VK_PLAY)      ' &HFA
        Call Test(VK_ZOOM)      ' &HFB
        Call Test(VK_NONAME)      ' &HFC
        Call Test(VK_PA1)      ' &HFD
        Call Test(VK_OEM_CLEAR)      ' &HFE
        
        Call Test(VK_TILDIE)
        Call Test(VK_BACKSLASH)
    End If
    
    If m_bReportCatigory_Alpha = True Then
        
        For i = Asc("A") To Asc("Z")
            If m_oFunctions.KeyPressed(i, bToggled) = True Then
                RaiseEvent KeyPressed(i, bToggled)
            End If
        Next i
        
        Call Test(VK_LSHIFT)      ' &HA0
        Call Test(VK_RSHIFT)      ' &HA1
        Call Test(VK_LCONTROL)      ' &HA2
        Call Test(VK_RCONTROL)      ' &HA3

        Call Test(VK_TAB)      ' &H9
        Call Test(VK_RETURN)      ' &HD
        Call Test(VK_ESCAPE)      ' &H1B
        Call Test(VK_SPACE)      ' &H20
        Call Test(VK_SHIFT)      ' &H10
        Call Test(VK_CONTROL)      ' &H11
        
    End If
    
    If m_bReportCatigory_Keypad = True Then
        Call Test(VK_NEXT)      ' &H22
        Call Test(VK_END)      ' &H23
        Call Test(VK_HOME)      ' &H24
        Call Test(VK_LEFT)      ' &H25
        Call Test(VK_UP)      ' &H26
        Call Test(VK_RIGHT)      ' &H27
        Call Test(VK_DOWN)      ' &H28
        Call Test(VK_NUMPAD0)      ' &H60
        Call Test(VK_NUMPAD1)      ' &H61
        Call Test(VK_NUMPAD2)      ' &H62
        Call Test(VK_NUMPAD3)      ' &H63
        Call Test(VK_NUMPAD4)      ' &H64
        Call Test(VK_NUMPAD5)      ' &H65
        Call Test(VK_NUMPAD6)      ' &H66
        Call Test(VK_NUMPAD7)      ' &H67
        Call Test(VK_NUMPAD8)      ' &H68
        Call Test(VK_NUMPAD9)      ' &H69
        Call Test(VK_MULTIPLY)      ' &H6A
        Call Test(VK_ADD)      ' &H6B
        Call Test(VK_SEPARATOR)      ' &H6C
        Call Test(VK_SUBTRACT)      ' &H6D
        Call Test(VK_DECIMAL)      ' &H6E
        Call Test(VK_DIVIDE)      ' &H6F
        Call Test(VK_NUMLOCK)      ' &H90
        Call Test(VK_SCROLL)      ' &H91

        For i = Asc("0") To Asc("9")
            If m_oFunctions.KeyPressed(i, bToggled) = True Then
                RaiseEvent KeyPressed(i, bToggled)
            End If
        Next i
        
    End If
    
    If m_bReportCatigory_FKeys = True Then
        Call Test(VK_F1)      ' &H70
        Call Test(VK_F2)      ' &H71
        Call Test(VK_F3)      ' &H72
        Call Test(VK_F4)      ' &H73
        Call Test(VK_F5)      ' &H74
        Call Test(VK_F6)      ' &H75
        Call Test(VK_F7)      ' &H76
        Call Test(VK_F8)      ' &H77
        Call Test(VK_F9)      ' &H78
        Call Test(VK_F10)      ' &H79
        Call Test(VK_F11)      ' &H7A
        Call Test(VK_F12)      ' &H7B
        Call Test(VK_F13)      ' &H7C
        Call Test(VK_F14)      ' &H7D
        Call Test(VK_F15)      ' &H7E
        Call Test(VK_F16)      ' &H7F
        Call Test(VK_F17)      ' &H80
        Call Test(VK_F18)      ' &H81
        Call Test(VK_F19)      ' &H82
        Call Test(VK_F20)      ' &H83
        Call Test(VK_F21)      ' &H84
        Call Test(VK_F22)      ' &H85
        Call Test(VK_F23)      ' &H86
        Call Test(VK_F24)      ' &H87
        
    End If
Call Test(0)
End Sub
Private Sub Test(nKey As ENUM_ASCII_KEYS)
    
    Dim bToggled As Boolean
    
    If m_oFunctions.KeyPressed(nKey, bToggled) = True Then
        RaiseEvent KeyPressed(nKey, bToggled)
    End If
    
End Sub
Private Sub UserControl_Initialize()
    m_bEnabled = True
    m_nPollingRate = 1
    UserControl.Width = Picture1.Width
    UserControl.Height = Picture1.Height
    m_bReportCatigory_Mouse = True
    m_bReportCatigory_Misc = True
    m_bReportCatigory_Alpha = True
    m_bReportCatigory_Keypad = True
    m_bReportCatigory_FKeys = True
End Sub

Private Sub UserControl_Resize()
    UserControl.Width = Picture1.Width
    UserControl.Height = Picture1.Height
End Sub
'Read in the properties, and if were running the code hook into the form
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
        
    m_nPollingRate = PropBag.ReadProperty("MyPollingRate", 1)
    Enabled = PropBag.ReadProperty("MyEnabled", True)
    m_bReportCatigory_Mouse = PropBag.ReadProperty("MyReportCatigory_Mouse", True)
    m_bReportCatigory_Misc = PropBag.ReadProperty("MyReportCatigory_Misc", True)
    m_bReportCatigory_Alpha = PropBag.ReadProperty("MyReportCatigory_Alpha", True)
    m_bReportCatigory_Keypad = PropBag.ReadProperty("MyReportCatigory_Keypad", True)
    m_bReportCatigory_FKeys = PropBag.ReadProperty("MyReportCatigory_FKeys", True)

End Sub
'Record the properties of the form
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("MyPollingRate", m_nPollingRate, 1)
    Call PropBag.WriteProperty("MyEnabled", m_bEnabled, True)
    Call PropBag.WriteProperty("MyReportCatigory_Mouse", m_bReportCatigory_Mouse, True)
    Call PropBag.WriteProperty("MyReportCatigory_Misc", m_bReportCatigory_Misc, True)
    Call PropBag.WriteProperty("MyReportCatigory_Alpha", m_bReportCatigory_Alpha, True)
    Call PropBag.WriteProperty("MyReportCatigory_Keypad", m_bReportCatigory_Keypad, True)
    Call PropBag.WriteProperty("MyReportCatigory_FKeys", m_bReportCatigory_FKeys, True)

End Sub
